zoukankan      html  css  js  c++  java
  • 1624: [Usaco2008 Open] Clear And Present Danger 寻宝之路

    1624: [Usaco2008 Open] Clear And Present Danger 寻宝之路

    Time Limit: 5 Sec  Memory Limit: 64 MB
    Submit: 377  Solved: 269
    [Submit][Status]

    Description

        农夫约翰正驾驶一条小艇在牛勒比海上航行.
        海上有N(1≤N≤100)个岛屿,用1到N编号.约翰从1号小岛出发,最后到达N号小岛.一
    张藏宝图上说,如果他的路程上经过的小岛依次出现了Ai,A2,…,AM(2≤M≤10000)这样的序列(不一定相邻),那他最终就能找到古老的宝藏.  但是,由于牛勒比海有海盗出没.约翰知道任意两个岛屿之间的航线上海盗出没的概率,他用一个危险指数Dij(0≤Dij≤100000)来描述.他希望他的寻宝活动经过的航线危险指数之和最小.那么,在找到宝藏的前提下,这个最小的危险指数是多少呢?

    Input

        第1行输入N和M,之后M行一行一个整数表示A序列,之后输入一个NxN的方阵,表示两两岛屿之间航线的危险指数.数据保证Dij=Dji,Dii=0.

    Output

     
        最小的危险指数和.

    Sample Input

    3 4
    1
    2
    1
    3
    0 5 1
    5 0 2
    1 2 0

    INPUT DETAILS:

    There are 3 islands and the treasure map requires Farmer John to
    visit a sequence of 4 islands in order: island 1, island 2, island
    1 again, and finally island 3. The danger ratings of the paths are
    given: the paths (1, 2); (2, 3); (3, 1) and the reverse paths have
    danger ratings of 5, 2, and 1, respectively.


    Sample Output

    7

    OUTPUT DETAILS:

    He can get the treasure with a total danger of 7 by traveling in
    the sequence of islands 1, 3, 2, 3, 1, and 3. The cow map's requirement
    (1, 2, 1, and 3) is satisfied by this route. We avoid the path
    between islands 1 and 2 because it has a large danger rating.

    HINT

     

    Source

    Silver

     题解:乍一看这个要求的路径还得经过如下的点,然后取最短路径,吓我一跳——直到我看到了必须依次经过以下点。。。这样一来就没啥了,先是Floyd一遍弄出各个点之间的最短路径,然后既然要求必须按序经过且不一定相邻,则直接累加各个段的最短路就Accept啦*^_^*。。。(PS:Floyd时不要排除a[i,k]或者a[k,j]为零的状况,因为在这个题目中不存在不直接相连的点,就算真的出现0,代表的也是真正意义上的两点距离为零,我虽然没有因此跪过但还是觉得最好留心点。。。)

     1 var
     2    i,j,k,m,n:longint;
     3    l:int64;
     4    a:array[0..200,0..200] of int64;
     5    b:array[0..20000] of longint;
     6 begin
     7      readln(n,m);
     8      for i:=1 to m do
     9          readln(b[i]);
    10      b[0]:=1;
    11      b[m+1]:=n;
    12      for i:=1 to n do
    13          begin
    14               for j:=1 to n do
    15                   read(a[i,j]);
    16               readln;
    17          end;
    18      for k:=1 to n do
    19          for i:=1 to n do
    20              begin
    21                   if (i=k) then continue;
    22                   for j:=1 to n do
    23                       begin
    24                            if (i=j) or (k=j) then continue;
    25                            if (a[i,k]+a[k,j])<a[i,j] then a[i,j]:=a[i,k]+a[k,j];
    26                       end;
    27              end;
    28      for i:=0 to m do
    29          l:=l+a[b[i],b[i+1]];
    30      writeln(l);
    31 end.
    32                    
  • 相关阅读:
    【转】为什么说面向对象编程和函数式编程都有问题
    【转】对博士学位说永别
    【转】写给支持和反对《完全用Linux工作》的人们
    【转】完全用Linux工作
    【转】人体工学
    【转】如何掌握所有的程序语言
    【转】Kotlin 和 Checked Exception
    【转】什么是现实理想主义者
    【转】经验和洞察力
    【转】C 编译器优化过程中的 Bug
  • 原文地址:https://www.cnblogs.com/HansBug/p/4168114.html
Copyright © 2011-2022 走看看